function dWdtheta = computedWdtheta (X1, X2, Y1, Y2, theta, i)
	[p1,n1] = size(X1);
	[p2,n2] = size(X2);
	if p1 ~= p2
		error('X1 and X2 should have same number of columns');
	end
	p = p1;

	M1 = repmat(mean(Y1, 2), 1, n1);
	E1 = Y1 - M1;
	dM1dtheta = repmat(computedFilterdtheta(mean(X1, 2), theta, i), 1, n1);
	dE1dtheta = computedFilterdtheta(X1, theta, i) - dM1dtheta;
	
	M2 = repmat(mean(Y2, 2), 1, n2);
	E2 = Y2 - M2;
	dM2dtheta = repmat(computedFilterdtheta(mean(X2, 2), theta, i), 1, n2);
	dE2dtheta = computedFilterdtheta(X2, theta, i) - dM2dtheta;
	
	dWdtheta = E1 * dE1dtheta' + dE1dtheta * E1' + ...
                   E2 * dE2dtheta' + dE2dtheta * E2';

	% Handle regularization
	global ALPHA;
	dWdtheta = (1 - ALPHA) * dWdtheta;
end
